#include <QCoreApplication>
#include <QTextDocument>
#include <QTextCursor>

#include <QDebug>
#include <QFile>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    qDebug() << "QT VERSION:" << QT_VERSION_STR;

    QTextDocument doc;

    QFile file(":/sample.html");

    if(!file.exists())
    {
        qDebug() << "File doesn't exist";
        return 1;
    }

    if(!file.open(QIODevice::ReadOnly))
    {
        qDebug() << "unable to open file";
        return 1;
    }

    doc.setHtml(file.readAll());

    QTextCursor cursor = QTextCursor(&doc);

    cursor.setPosition(0);
    cursor.setPosition(QString("Hello world").length(), QTextCursor::KeepAnchor);

    qDebug() << "Text cursor selection:" << cursor.selectedText();

    QTextCharFormat format;
    const QString fontFamily = "Jokerman";

    if(a.arguments().contains("-workaround"))
        format.setFont(QFont(fontFamily));
    else
        format.setFontFamily(fontFamily);

    qDebug() << "QTextCharFormat font:" << format.font();

    qDebug() << "QCursor::mergeCharFormat";
    cursor.mergeCharFormat(format);

    qDebug() << "Resulting doc to html:";
    qDebug() << doc.toHtml();

    return a.exec();
}
